#!/usr/bin/env bash


url="http://127.0.0.1:$1/log_agent/health"

prev_code="NORMAL"
error_send_mail=0

echo "脚本运行中。。。"
while true;
do
  code=$(curl -m 10 -o /dev/null -s -w %{http_code} ${url})
  if [ ${code} -eq 200 ];then
    res=$(curl -s -connect-timeout 2 ${url})
    code=${res%|*}
    message=${res#*|}
    if [ ${code} == "NORMAL" ];then
        if [ ${prev_code} != "NORMAL" ];then
          echo "LogAgent 恢复正常！"
          echo "LogAgent 服务恢复正常！"|mail -s "LogAgent Recover" $2
        else
          echo "LogAgent 心跳正常"
          error_send_mail=0
        fi
    elif [ ${code} == "ABORT" ] && [ prev_code != "ABORT" ];then
        echo "LogAgent 服务不稳定！"
        echo "LogAgent 服务不稳定，最近10分钟中发生过多次重启，最新一次异常信息："${message} |mail -s "LogAgent WARN" $2
    elif [ ${code} == "ERROR" ] && [ prev_code != "ERROR" ]; then
        echo "LogAgent 服务一分钟之内发生过异常！"
        echo "LogAgent 服务异常，最近1分钟中发生过重启，异常信息："${message} |mail -s "LogAgent WARN" $2
    prev_code=${code}
    fi
  else
    echo "LogAgent 接口访问异常！"
    if [ ${error_send_mail} -lt 3 ];then
      echo "LogAgent 服务异常，接口无法访问。" |mail -s "LogAgent ERROR" $2
      error_send_mail=${error_send_mail}+1
    fi
  fi
  sleep 60
done




